
#include "..\C-Engine\CHeader.hpp"
#include "Menu.hpp"
#include "Save.hpp"

int StereoMadness(Save * UserSave);
int BackOnTrack(Save * UserSave);
int Polargeist(Save * UserSave);

void Menu()
{
    Save * UserSave = new Save();
    UserSave->LoadData();

    bool end = false;
    int choix = 0;

    const unsigned char S1[]={0xff, 0x80, 0x7f, 0xff, 0xff, 0xbf, 0x7f, 0xff, 0xff, 0xbf, 0x7f, 0xff, 0xe0, 0x3f, 0x0, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0x0, 0x27, 0x0, 0x1f, 0x7f, 0xeb, 0xff, 0xdf, 0x7f, 0xed, 0xff, 0xdf, 0x7f, 0xee, 0xff, 0xdf, 0x7f, 0xee, 0xff, 0xdf, 0x7f, 0xed, 0xff, 0xdf, 0x7f, 0xeb, 0xff, 0xdf, 0x0, 0x27, 0x0, 0x1f, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xef, 0xbf, 0x7e, 0xff, 0xe0, 0x3f, 0x0, 0xff, 0xff, 0xbf, 0x7f, 0xff, 0xff, 0xbf, 0x7f, 0xff, 0xff, 0x80, 0x7f, 0xff, };
    const unsigned char S2[]={0xfe, 0x7, 0xff, 0xfe, 0xf7, 0xff, 0xc0, 0xf0, 0x3f, 0xde, 0xf7, 0xbf, 0xd0, 0x0, 0xbf, 0xd7, 0xfe, 0xbf, 0xd4, 0x62, 0xbf, 0x5, 0x6a, 0xf, 0x74, 0x62, 0xef, 0x77, 0xfe, 0xef, 0x77, 0xfe, 0xef, 0x74, 0x2, 0xef, 0x5, 0xfa, 0xf, 0xd4, 0x2, 0xbf, 0xd7, 0xfe, 0xbf, 0xd0, 0x0, 0xbf, 0xde, 0xf7, 0xbf, 0xc0, 0xf0, 0x3f, 0xfe, 0xf7, 0xff, 0xfe, 0x7, 0xff, };
    const unsigned char S3[]={0xf0, 0x7f, 0xef, 0xbf, 0xdf, 0xdf, 0xbf, 0xef, 0x70, 0x77, 0x4f, 0x97, 0x2d, 0xa7, 0x55, 0x57, 0x6a, 0xb7, 0xbd, 0xef, 0xd8, 0xdf, 0xef, 0xbf, 0xf0, 0x7f, };
    const unsigned char S4[]={0xf0, 0x7f, 0xef, 0xbf, 0xdf, 0xdf, 0xbd, 0xef, 0x78, 0xf7, 0x77, 0x77, 0x67, 0x37, 0x77, 0x77, 0x78, 0xf7, 0xbd, 0xef, 0xdf, 0xdf, 0xef, 0xbf, 0xf0, 0x7f, };
    const unsigned char S5[]={0xf0, 0x7f, 0xef, 0xbf, 0xdf, 0xdf, 0xbf, 0xef, 0x67, 0x97, 0x64, 0x97, 0x64, 0x97, 0x64, 0x97, 0x64, 0x97, 0xa4, 0x8f, 0xdf, 0xdf, 0xef, 0xbf, 0xf0, 0x7f, };
    const unsigned char S6[]={0xf0, 0x7f, 0xef, 0xbf, 0xdf, 0xdf, 0xbf, 0x6f, 0x7c, 0x77, 0x7b, 0x77, 0x7b, 0x77, 0x7a, 0x77, 0x72, 0x77, 0xb3, 0xef, 0xdf, 0xdf, 0xef, 0xbf, 0xf0, 0x7f, };
    const unsigned char S7[]={0xfe, 0x7, 0xff, 0xfe, 0xf7, 0xff, 0xc0, 0xf0, 0x3f, 0xde, 0xf7, 0xbf, 0xd0, 0x0, 0xbf, 0xd7, 0xfe, 0xbf, 0xd6, 0x6, 0xbf, 0x4, 0x1e, 0xf, 0x74, 0x7e, 0xef, 0x74, 0xfe, 0xef, 0x74, 0xfe, 0xef, 0x74, 0x76, 0xef, 0x4, 0x26, 0xf, 0xd6, 0x6, 0xbf, 0xd7, 0xfe, 0xbf, 0xd0, 0x0, 0xbf, 0xde, 0xf7, 0xbf, 0xc0, 0xf0, 0x3f, 0xfe, 0xf7, 0xff, 0xfe, 0x7, 0xff, };

    const unsigned char N1[]={0x0, 0x7f, 0x80, 0x1f, 0x0, 0x7f, 0x80, 0x1f, 0x0, 0x7f, 0x80, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x1f, 0xff, 0xff, 0x1f, 0x0, 0x7f, 0x80, 0x1f, 0x0, 0x7f, 0x80, 0x1f, 0x0, 0x7f, 0x80, 0x1f, };
    const unsigned char N2[]={0x1, 0xf8, 0xf, 0x1, 0xf8, 0xf, 0x3f, 0xff, 0xcf, 0x3f, 0xff, 0xcf, 0x3f, 0xff, 0xcf, 0x3f, 0xff, 0xcf, 0x3f, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xcf, 0x3f, 0xff, 0xcf, 0x3f, 0xff, 0xcf, 0x3f, 0xff, 0xcf, 0x3f, 0xff, 0xcf, 0x1, 0xf8, 0xf, 0x1, 0xf8, 0xf, };
    const unsigned char N3[]={0xf, 0x87, 0x1f, 0xc7, 0x3f, 0xe7, 0x7f, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xf7, 0x3f, 0xe7, 0x1f, 0xc7, 0xf, 0x87, };

    const unsigned char smenu[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x1, 0xe7, 0x88, 0xc7, 0xbe, 0x70, 0x80, 0x1f, 0x1c, 0x71, 0x20, 0x0, 0x0, 0x0, 0x0, 0x3, 0x33, 0xd, 0xdd, 0xec, 0x18, 0xd9, 0xd0, 0xd, 0xb6, 0xc1, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x33, 0xcc, 0xdf, 0x6f, 0x18, 0xf9, 0xf0, 0xd, 0xb6, 0xc1, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x33, 0xc, 0xdb, 0x6c, 0x18, 0xf0, 0xf0, 0xd, 0xbe, 0xf9, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xf3, 0x47, 0xd9, 0x6d, 0x18, 0xd8, 0x70, 0xd, 0xbe, 0x19, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xd1, 0xc3, 0x90, 0x67, 0x8, 0xc9, 0xf0, 0xf, 0x36, 0x19, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x40, 0x0, 0x40, 0xe0, 0x6, 0x10, 0x30, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xfc, 0x0, 0x1, 0xfc, 0xf, 0xf0, 0x0, 0xf, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x84, 0x0, 0x1, 0x4, 0x8, 0x10, 0x0, 0x8, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x87, 0xe0, 0x1, 0x4, 0x8, 0x10, 0x1, 0xf8, 0x7e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x84, 0x20, 0x1, 0x4, 0x8, 0x10, 0x1, 0x8, 0x42, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x17, 0xff, 0xa0, 0x1, 0x4, 0x8, 0x10, 0x1, 0x7f, 0xfa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x14, 0x0, 0xa0, 0x1, 0x4, 0x8, 0x10, 0x1, 0x40, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x15, 0xce, 0xa0, 0xf, 0xfd, 0x8f, 0xfe, 0x1, 0x4f, 0xca, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7d, 0x4a, 0xf8, 0x8, 0x1, 0x40, 0x2, 0x7, 0xdf, 0xf, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x45, 0xce, 0x88, 0x8, 0x1, 0x20, 0x2, 0x4, 0x5c, 0x8, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x44, 0x0, 0x88, 0x8, 0x1, 0x10, 0x2, 0x4, 0x58, 0x8, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x44, 0x0, 0x88, 0x8, 0x1, 0x10, 0x2, 0x4, 0x58, 0x8, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x45, 0xfe, 0x88, 0x8, 0x1, 0x20, 0x2, 0x4, 0x5c, 0x48, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7d, 0x2, 0xf8, 0x8, 0x1, 0x40, 0x2, 0x7, 0xde, 0xcf, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x15, 0xfe, 0xa0, 0xf, 0xfd, 0x8f, 0xfe, 0x1, 0x4f, 0xca, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x14, 0x0, 0xa0, 0x1, 0x4, 0x8, 0x10, 0x1, 0x40, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x17, 0xff, 0xa0, 0x1, 0x4, 0x8, 0x10, 0x1, 0x7f, 0xfa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x84, 0x20, 0x1, 0x4, 0x8, 0x10, 0x1, 0x8, 0x42, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x87, 0xe0, 0x1, 0x4, 0x8, 0x10, 0x1, 0xf8, 0x7e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x84, 0x0, 0x1, 0x4, 0x8, 0x10, 0x0, 0x8, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xfc, 0x0, 0x1, 0x4, 0x8, 0x10, 0x0, 0xf, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xfc, 0xf, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x80, 0x0, 0x20, 0x80, 0x0, 0x20, 0x80, 0x0, 0x20, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x40, 0x0, 0x40, 0x40, 0x0, 0x40, 0x40, 0x0, 0x40, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x20, 0x0, 0x84, 0x20, 0x0, 0x80, 0x20, 0x0, 0x81, 0x20, 0x0, 0x0, 0x0, 0x0, 0x1, 0x1f, 0x10, 0x1, 0xe, 0x10, 0x1, 0x30, 0xd0, 0x1, 0x7, 0x10, 0x0, 0x0, 0x0, 0x0, 0x1, 0x60, 0xd0, 0x1, 0x11, 0x10, 0x1, 0x36, 0xd0, 0x1, 0x9, 0x10, 0x0, 0x0, 0x0, 0x0, 0x1, 0xa4, 0xb0, 0x1, 0x31, 0x90, 0x1, 0x36, 0xd0, 0x1, 0x9, 0x10, 0x0, 0x0, 0x0, 0x0, 0x1, 0x55, 0x50, 0x1, 0x11, 0x10, 0x1, 0x36, 0xd0, 0x1, 0xb, 0x10, 0x0, 0x0, 0x0, 0x0, 0x1, 0x2a, 0x90, 0x1, 0xe, 0x10, 0x1, 0x36, 0xd0, 0x1, 0x1b, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x84, 0x20, 0x0, 0x84, 0x20, 0x0, 0xb6, 0xe0, 0x0, 0x98, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4e, 0x40, 0x0, 0x40, 0x40, 0x0, 0x40, 0x40, 0x0, 0x40, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x80, 0x0, 0x20, 0x80, 0x0, 0x20, 0x80, 0x0, 0x20, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, };
    const unsigned char smini[]={0x46, 0x22, 0x25, 0xef, 0x77, 0x6f, 0xfb, 0x77, 0xcf, 0xdb, 0x66, 0xcd, 0xcb, 0x66, 0x4d, 0x83, 0x44, 0x9, 0x2, 0x0, 0x1, };



    Sleep(200);

    while(end == false)
    {
        ML_clear_vram();

        input_update();

        ML_bmp_or(smenu , 0 ,0 , 128 , 64);

        if(input_any_key())
        {
            if(input_trigger(K_RIGHT))choix ++;
            if(input_trigger(K_LEFT))choix --;
            if(input_trigger(K_UP))choix -= 4;
            if(input_trigger(K_DOWN))choix += 3;

            if(input_trigger(K_EXIT))
            {
                UserSave->SaveData();
                delete UserSave;
                return;
            }

            if(choix < 0)choix = 6;
            if(choix > 6)choix = 0;


            if(input_trigger(K_EXE) || input_trigger(K_SHIFT))
            {
                switch(choix)
                {
                    case 0: SelectLevel(UserSave); break;
                    case 1: Credit(); break;
                    case 2: /*Score(UserSave);*/ break;
                    case 3: Option(UserSave); break;
                    case 4: Info(UserSave); break;
                    case 5: Music();break;
                    case 6: SelectCube(UserSave); break;
                }
            }
        }

        switch(choix)
                {
                    case 0: ML_bmp_or(N1 , 52,17 , 27 ,27); ML_bmp_and(S1 , 52,17 , 27 ,27); break;
                    case 1: ML_bmp_or(N2 , 85,20 , 20 ,20); ML_bmp_and(S7 , 85,20 , 20 ,20); break;
                    case 2: ML_bmp_or(N3 , 23,50 , 13 ,13); ML_bmp_and(S3 , 23,50 , 13 ,13); break;
                    case 3: ML_bmp_or(N3 , 47,50 , 13 ,13); ML_bmp_and(S4 , 47,50 , 13 ,13); break;
                    case 4: ML_bmp_or(N3 , 71,50 , 13 ,13); ML_bmp_and(S5 , 71,50 , 13 ,13); break;
                    case 5: ML_bmp_or(N3 , 95,50 , 13 ,13); ML_bmp_and(S6 , 95,50 , 13 ,13); break;
                    case 6: ML_bmp_or(N2 , 25,20 , 20 ,20); ML_bmp_and(S2 , 25,20 , 20 ,20); break;
                }

        if(UserSave->UserInfo->mini == 1) ML_bmp_or(smini , 101,14 , 23 ,7);

        ML_display_vram();
    }

}

void SelectLevel(Save * UserSave)
{
    bool end = false;
    int choix = 0;

    const unsigned char sns[]={0x0, 0x0, 0x0, 0x0, 0x11, 0x0, 0x0, 0x20, 0x4, 0x0, 0x0, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x11, 0x0, 0x0, 0x20, 0x4, 0x0, 0x0, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x20, 0x4, 0x0, 0x0, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xff, 0xff, 0xe0, 0x7, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xe0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x10, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0x3, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0xc, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0xc0, 0x2, 0x10, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x3, 0x0, 0x1, 0x40, 0x2, 0x20, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x80, 0x2, 0x40, 0x2, 0x20, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x40, 0x4, 0x40, 0x2, 0x40, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x20, 0x8, 0x40, 0x2, 0x40, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x10, 0x10, 0x40, 0x2, 0x40, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x8, 0x8, 0x40, 0x2, 0x40, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x10, 0x4, 0x40, 0x2, 0x40, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x20, 0x2, 0x40, 0x2, 0x20, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x40, 0x1, 0x40, 0x2, 0x20, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x2, 0x80, 0x0, 0xc0, 0x2, 0x10, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x3, 0x0, 0x0, 0x0, 0x2, 0xc, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0x3, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xc, 0x30, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x92, 0x48, 0x40, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x92, 0x48, 0x40, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xc, 0x30, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x10, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x8, 0x10, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x8, 0x10, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x8, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xf, 0x80, 0x0, 0x0, 0x0, 0x0, 0x3, 0xc, 0x30, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf0, 0x8, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x92, 0x49, 0x20, 0x0, 0x0, 0x0, 0x0, 0xf, 0x10, 0x8, 0x90, 0x0, 0x0, 0x0, 0x0, 0x3, 0xc, 0x30, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x9, 0x10, 0x8, 0x90, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x9, 0x10, };

    const unsigned char Smiley1[]={0x7, 0xc1, 0x18, 0x31, 0x20, 0x9, 0x40, 0x5, 0x4c, 0xc5, 0x8c, 0xc3, 0x8c, 0xc3, 0x8c, 0xc3, 0x80, 0x3, 0x8f, 0xe3, 0x48, 0x25, 0x47, 0xc5, 0x20, 0x9, 0x18, 0x31, 0x7, 0xc1, };
    const unsigned char Smiley2[]={0x7, 0xc1, 0x18, 0x31, 0x20, 0x9, 0x40, 0x5, 0x4c, 0xc5, 0x8c, 0xc3, 0x8c, 0xc3, 0x8c, 0xc3, 0x80, 0x3, 0x80, 0x3, 0x48, 0x25, 0x47, 0xc5, 0x20, 0x9, 0x18, 0x31, 0x7, 0xc1, };
    const unsigned char Smiley3[]={0x7, 0xc1, 0x18, 0x31, 0x20, 0x9, 0x40, 0x5, 0x4c, 0xc5, 0x8c, 0xc3, 0x8c, 0xc3, 0x88, 0x83, 0x80, 0x3, 0x80, 0x3, 0x40, 0x5, 0x4f, 0xc5, 0x20, 0x9, 0x18, 0x31, 0x7, 0xc1, };
    const unsigned char Smiley4[]={0x7, 0xc1, 0x18, 0x31, 0x20, 0x9, 0x40, 0x5, 0x46, 0xc5, 0x86, 0xc3, 0x86, 0xc3, 0x82, 0x83, 0x80, 0x3, 0x80, 0x3, 0x43, 0x85, 0x44, 0x45, 0x20, 0x9, 0x18, 0x31, 0x7, 0xc1, };
    const unsigned char Smiley5[]={0x7, 0xc1, 0x18, 0x31, 0x20, 0x9, 0x46, 0xc5, 0x46, 0xc5, 0x86, 0xc3, 0x82, 0x83, 0x80, 0x3, 0x80, 0x3, 0x83, 0x83, 0x44, 0x45, 0x47, 0xc5, 0x20, 0x9, 0x18, 0x31, 0x7, 0xc1, };



   while(end == false)
    {
        ML_clear_vram();

        input_update();

        ML_bmp_or(sns , 0 ,0 , 128 , 64);
        if(choix == 3)ML_rectangle(20,10,110,58,1,ML_WHITE , ML_WHITE);

        if(input_any_key())
        {
            if(input_trigger(K_RIGHT))choix ++;
            if(input_trigger(K_LEFT))choix --;

            if(input_trigger(K_EXIT))return;

            if(choix < 0)choix = 3;
            if(choix > 3)choix = 0;


            if(input_trigger(K_EXE)|| input_trigger(K_SHIFT))
            {
                switch(choix)
                {
                    case 0: StereoMadness(UserSave); break;
                    case 1: BackOnTrack(UserSave); break;
                    case 2: Polargeist(UserSave); break;
                    case 3:  break;
                }


            }
        }

        switch(choix)
                {
                    case 0:
                        PrintMini(44,20,"Stereo Madness",0);
                        ML_bmp_or(Smiley1 , 25, 17, 15, 15);
                        ML_line(24,47,24 + UserSave->TabLevel[choix]->normalprogress * 76 / 100,47, ML_BLACK);
                        ML_line(24,57,24 + UserSave->TabLevel[choix]->practiseprogress * 76 / 100,57, ML_BLACK);
                        ML_line(54,61,56,61, ML_BLACK); PrintV(58,40,UserSave->TabLevel[choix]->normalprogress);
                        PrintV(58,50,UserSave->TabLevel[choix]->practiseprogress);
                    break;
                    case 1:
                        PrintMini(44,20,"Back On Track",0);
                        ML_bmp_or(Smiley3 , 25, 17, 15, 15);
                        ML_line(24,47,24 + UserSave->TabLevel[choix]->normalprogress * 76 / 100,47, ML_BLACK);
                        ML_line(24,57,24 + UserSave->TabLevel[choix]->practiseprogress * 76 / 100,57, ML_BLACK);
                        ML_line(60,61,62,61, ML_BLACK);  PrintV(58,40,UserSave->TabLevel[choix]->normalprogress);
                        PrintV(58,50,UserSave->TabLevel[choix]->practiseprogress);
                    break;
                    case 2:
                        PrintMini(44,20,"Polargeist",0);
                        ML_bmp_or(Smiley5 , 25, 17, 15, 15);
                        ML_line(24,47,24 + UserSave->TabLevel[choix]->normalprogress * 76 / 100,47, ML_BLACK);
                        ML_line(24,57,24 + UserSave->TabLevel[choix]->practiseprogress * 76 / 100,57, ML_BLACK);
                        ML_line(66,61,68,61, ML_BLACK);  PrintV(58,40,UserSave->TabLevel[choix]->normalprogress);
                        PrintV(58,50,UserSave->TabLevel[choix]->practiseprogress);
                    break;
                    case 3:
                        PrintMini(44,20,"Coming Soon",0);
                        ML_line(72,61,74,61, ML_BLACK);break;
                }

        ML_display_vram();
    }
}

void SelectCube(Save * UserSave)
{
    bool end = false;
    int choix = 0;

 const unsigned char ssc[]={0x8, 0x90, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x9, 0x10, 0x8, 0x90, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x9, 0x10, 0x8, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x10, 0xf, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf0, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x8, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xe0, 0x8, 0x10, 0x70, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xc0, 0x8, 0xf0, 0x90, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x20, 0xf, 0x21, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x22, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xe1, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x7, 0x0, 0x90, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x40, 0x0, 0x0, 0x70, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x40, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xc0, 0x7f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, 0xc0, 0x60, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x81, 0x40, 0x50, 0x28, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x42, 0x40, 0x48, 0x48, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x24, 0x40, 0x44, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x18, 0x40, 0x43, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x18, 0x40, 0x43, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x24, 0x40, 0x44, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x42, 0x40, 0x48, 0x48, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x81, 0x40, 0x50, 0x28, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, 0xc0, 0x60, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xc0, 0x7f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, };

    const unsigned char ss[]={0x40, 0x2, 0xc0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc0, 0x3, 0x40, 0x2, };

    const unsigned char P1[]={0xff, 0xff, 0x80, 0x1f, 0x80, 0x1f, 0x9f, 0x9f, 0x90, 0x9f, 0x90, 0x9f, 0x90, 0x9f, 0x90, 0x9f, 0x9f, 0x9f, 0x80, 0x1f, 0x80, 0x1f, 0xff, 0xff, };
    const unsigned char P2[]={0xff, 0xff, 0x80, 0x1f, 0x80, 0x1f, 0xbf, 0xdf, 0xa0, 0x5f, 0xef, 0x7f, 0x9, 0xf, 0xf9, 0xff, 0x80, 0x1f, 0x80, 0x1f, 0x80, 0x1f, 0xff, 0xff, };
    const unsigned char P3[]={0xff, 0xff, 0x80, 0x1f, 0x80, 0x1f, 0xb9, 0xdf, 0xa9, 0x5f, 0xb9, 0xdf, 0x80, 0x1f, 0xbf, 0xdf, 0xa0, 0x5f, 0xbf, 0xdf, 0x80, 0x1f, 0xff, 0xff, };
    const unsigned char P4[]={0xff, 0xff, 0x80, 0x1f, 0xb9, 0xdf, 0xa9, 0x5f, 0xb9, 0xdf, 0x80, 0x1f, 0xb9, 0xdf, 0xef, 0x7f, 0x0, 0xf, 0xff, 0xff, 0x80, 0x1f, 0xff, 0xff, };
    const unsigned char P5[]={0xff, 0xff, 0x80, 0x1f, 0x9f, 0x9f, 0x90, 0x9f, 0x9f, 0x9f, 0x80, 0x1f, 0x80, 0x1f, 0xb9, 0xdf, 0xa9, 0x5f, 0xa9, 0x5f, 0xa9, 0x5f, 0xef, 0x7f, };
    const unsigned char P6[]={0xff, 0xff, 0x80, 0x1f, 0x8f, 0x1f, 0x89, 0x1f, 0x89, 0x1f, 0x89, 0x1f, 0x89, 0x1f, 0x8f, 0x1f, 0xe0, 0x7f, 0x20, 0x4f, 0x20, 0x4f, 0x3f, 0xcf, };
    const unsigned char P7[]={0xf9, 0xff, 0x89, 0x1f, 0x89, 0x1f, 0x89, 0x1f, 0x8f, 0x1f, 0x80, 0x1f, 0x80, 0x1f, 0x8f, 0x1f, 0x89, 0x1f, 0x89, 0x1f, 0x89, 0x1f, 0xf9, 0xff, };
    const unsigned char P8[]={0x7f, 0xef, 0xc0, 0x3f, 0x80, 0x1f, 0x83, 0xdf, 0xba, 0x5f, 0xaa, 0x5f, 0xbb, 0xdf, 0x80, 0x1f, 0xe0, 0x7f, 0x2f, 0x4f, 0x29, 0x4f, 0x39, 0xcf, };


   while(end == false)
    {
        ML_clear_vram();

        input_update();

        ML_bmp_or(ssc , 0 ,0 , 128 , 64);

        ML_bmp_or(P1,21,27,12,12);
        ML_bmp_or(P2,40,27,12,12);
        ML_bmp_or(P3,59,27,12,12);
        ML_bmp_or(P4,78,27,12,12);
        ML_bmp_or(P5,97,27,12,12);
        ML_bmp_or(P6,21,44,12,12);
        ML_bmp_or(P7,40,44,12,12);
        ML_bmp_or(P8,59,44,12,12);

        switch(UserSave->UserInfo->perso)
        {
            case 0:  ML_bmp_or(P1,57,8,12,12);  break;
            case 1:  ML_bmp_or(P2,57,8,12,12);  break;
            case 2:  ML_bmp_or(P3,57,8,12,12);  break;
            case 3:  ML_bmp_or(P4,57,8,12,12);  break;
            case 4:  ML_bmp_or(P5,57,8,12,12);  break;
            case 5:  ML_bmp_or(P6,57,8,12,12);  break;
            case 6:  ML_bmp_or(P7,57,8,12,12);  break;
            case 7:  ML_bmp_or(P8,57,8,12,12);  break;
        }

        if(input_any_key())
        {
            if(input_trigger(K_RIGHT))choix ++;
            if(input_trigger(K_LEFT))choix --;
            if(input_trigger(K_UP))choix -= 5;
            if(input_trigger(K_DOWN))choix += 5;

            if(input_trigger(K_EXIT))return;

            if(choix < 0)choix = 9;
            if(choix > 9)choix = 0;


            if(input_trigger(K_EXE)|| input_trigger(K_SHIFT))
            {
                switch(choix)
                {
                    case 0:  UserSave->UserInfo->perso = 0;   break;
                    case 1:  UserSave->UserInfo->perso = 1;   break;
                    case 2:  UserSave->UserInfo->perso = 2;   break;
                    case 3:  UserSave->UserInfo->perso = 3;   break;
                    case 4:  UserSave->UserInfo->perso = 4;   break;
                    case 5:  UserSave->UserInfo->perso = 5;   break;
                    case 6:  UserSave->UserInfo->perso = 6;   break;
                    case 7:  UserSave->UserInfo->perso = 7;   break;
                    case 8:    break;
                    case 9:    break;
                }
            }
        }

        switch(choix)
                {
                    case 0:ML_bmp_or(ss , 19 , 25 , 16 , 16);      break;
                    case 1:ML_bmp_or(ss , 38 , 25 , 16 , 16);      break;
                    case 2:ML_bmp_or(ss , 57 , 25 , 16 , 16);      break;
                    case 3:ML_bmp_or(ss , 76 , 25 , 16 , 16);      break;
                    case 4:ML_bmp_or(ss , 95 , 25 , 16 , 16);      break;
                    case 5:ML_bmp_or(ss , 19 , 42 , 16 , 16);      break;
                    case 6:ML_bmp_or(ss , 38 , 42 , 16 , 16);      break;
                    case 7:ML_bmp_or(ss , 57 , 42 , 16 , 16);      break;
                    case 8:ML_bmp_or(ss , 76 , 42 , 16 , 16);      break;
                    case 9:ML_bmp_or(ss , 95 , 42 , 16 , 16);      break;
                }

        ML_display_vram();
    }
}

void Info(Save * UserSave)
{
    const unsigned char sinfo[]={0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x14, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x1, 0xe7, 0xcf, 0x3e, 0x78, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x1, 0x1, 0x9, 0x8, 0x40, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x1, 0x1, 0x9, 0x8, 0x40, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x1, 0xe1, 0xf, 0x8, 0x78, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x21, 0x9, 0x8, 0x8, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x21, 0x9, 0x8, 0x8, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x1, 0xe1, 0x9, 0x8, 0x78, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x1c, 0x9d, 0xd0, 0x3a, 0xab, 0x80, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0x50, 0x12, 0xba, 0x90, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0xd0, 0x12, 0xab, 0x80, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0x50, 0x12, 0xaa, 0x10, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x8, 0x89, 0x5c, 0x33, 0xaa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x1c, 0x9d, 0xd0, 0x3b, 0xbb, 0xab, 0xbb, 0x80, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0x50, 0x29, 0x12, 0x3a, 0x92, 0x10, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0xd0, 0x39, 0x13, 0x2b, 0x93, 0x80, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0x50, 0x29, 0x12, 0x2a, 0x10, 0x90, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x8, 0x89, 0x5c, 0x29, 0x13, 0xaa, 0x13, 0x80, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x1c, 0x9d, 0xd0, 0x39, 0x2b, 0x80, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0x50, 0x10, 0x3a, 0x10, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0xd0, 0x11, 0x2b, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x9, 0x49, 0x50, 0x11, 0x2a, 0x10, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x8, 0x89, 0x5c, 0x11, 0x2b, 0x80, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x40, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x2, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x40, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x2, 0x8, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xc0, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x3, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0x80, 0x3, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, };

    ML_clear_vram();

    ML_bmp_or(sinfo,0,0,127,63);

    PrintV(71,26,UserSave->UserInfo->nbjump);
    PrintV(86,35,UserSave->UserInfo->nbattemp);
    PrintV(71,44,UserSave->UserInfo->nbtime);

    ML_display_vram();

    while(!input_trigger(K_EXIT))
    {
        input_update();
    }
}

void Option(Save * UserSave)
{
    if(UserSave->UserInfo->mini == 0)UserSave->UserInfo->mini = 1;
    else UserSave->UserInfo->mini = 0;
}

void Music()
{
    const unsigned char smusic[]={0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x14, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x40, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x2, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x40, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x2, 0x8, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xc0, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x3, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0x80, 0x3, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, };

    ML_clear_vram();
    ML_bmp_or(smusic,0,0,127,63);
    PrintMini(48,10,"Youtube",0);
    PrintMini(52,22,"Fife86",0);
    PrintMini(32,40,"Pour + de videos",0);


    ML_display_vram();

    while(!input_trigger(K_EXIT))
    {
        input_update();
    }
}

void Credit()
{
     bool cinematic = true;

     int time = 0;
     int texty = 50;

    while(cinematic == true)
    {
        input_update();

        if(input_trigger(K_EXIT))return;

        time ++;
        texty --;
        if(time > 130) cinematic = false;

        ML_clear_vram();

        PrintXY(40,texty, "Credits:",0);
        PrintMini(20,texty + 25, "Cree par Fife86",0);
        PrintMini(40,texty + 40, "Designs :",0);
        PrintMini(20,texty + 50, "Fife86",0);
        PrintMini(20,texty + 60, "Casio-Jawa",0);
        PrintMini(20,texty + 70, "Lephenixnoir",0);

        ML_display_vram();

        Sleep(75);
    }

}
